/**
 * $Id: OrderedSetAsSetFactory.java,v 1.2 2006/01/31 18:27:40 uwe Exp $
 */
package de.fhw.data.set.referenceImpl;

import de.fhw.data.function.Fct2;
import de.fhw.data.function.Predef;
import de.fhw.data.set.Set;
import de.fhw.data.set.SetFactory;

/**
 * A concrete factory for ordered set implementations via normal sets.
 * 
 * @param <E> the element type
 */

public
class OrderedSetAsSetFactory<E extends Comparable<? super E>>
implements SetFactory<E> {
	final SetFactory<E> sf;
	final Fct2<E,E,Integer> cp = Predef.cmp();
	/**
	 * 
	 * @param sf the factory for the underlying set implementation.
	 */
	public OrderedSetAsSetFactory(SetFactory<E> sf) {
		this.sf = sf;
	}
	/**
	 * the default set factory is for the reference implementation
	 * in de.fhw.data.set.referenceImpl, a very inefficient one
	 *
	 */
	public OrderedSetAsSetFactory() {
		this(new SetAsMapFactory<E>());
	}
	/**
	 * generation of an empty set. The result can be used as a prototype.
	 */
	public Set<E> empty() {
		return
		new OrderedSetAsSetImpl<E>(cp,sf);
	}
}
